"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * gufuyan
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @content 滚动条组件
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @date 2017-05-24 1.0版本
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var style = {
    scrollBoxWrap: {
        position: "relative",
        width: "100%",
        height: "100%",
        overflow: "hidden"
    },
    scrollContentWrap: {
        zIndex: 1,
        position: "absolute",
        left: 0,
        top: 0,
        right: 0,
        bottom: 0,
        overflowY: "scroll",
        overflowX: "hidden"
    },
    scrollBarWrap: {
        position: "absolute",
        height: "100%",
        right: "0",
        top: "0",
        zIndex: 2
    },
    scrollBar: {
        position: "absolute",
        left: 0,
        right: 0,
        borderRadius: "0.25rem",
        cursor: "pointer"
    }
};

var ScrollBox = function (_Component) {
    _inherits(ScrollBox, _Component);

    function ScrollBox(props) {
        _classCallCheck(this, ScrollBox);

        var _this = _possibleConstructorReturn(this, (ScrollBox.__proto__ || Object.getPrototypeOf(ScrollBox)).call(this, props));

        _this.componentDidUpdate = function () {
            var shouldUpdate = _this.props.shouldUpdate;
            if (shouldUpdate) {
                setTimeout(function () {
                    _this.scrollBarStateChange();
                    _this.props.initScroll();
                }, 100);
            }
        };

        _this.state = {
            wrapHeight_1: 0,
            contentHeight_1: 0,
            scrollHeight_1: 0,
            mouseDown_1: false,
            startPos_1: 0,
            botFixed_1: false,

            needScrollBar: false,
            scrollBarTop: 0,
            scrollBarBot: 0,
            realScrollBarWidth: 0,
            scrollBarWidth: 6, // 滚动条宽度
            scrollWrapColor: "white", // 滚动条容器背景颜色
            scrollBarColor: "rgb(231, 231, 231)" // 滚动条颜色
        };
        return _this;
    }

    _createClass(ScrollBox, [{
        key: "scrollBarStateChange",
        value: function scrollBarStateChange() {
            var scrollContentWrap = this.refs.scrollContentWrap;
            var scrollContent = this.refs.scrollContent;
            var wrapHeight = scrollContentWrap.clientHeight;
            //console.log(wrapHeight+"-------------------------------")
            var contentHeight = scrollContent.clientHeight;
            if (contentHeight < wrapHeight) return;

            var scrollHeight = (wrapHeight / contentHeight * 100).toFixed(2);
            var scrollTop = (scrollContentWrap.scrollTop / contentHeight * 100).toFixed(2);

            if (parseInt(this.state.scrollBarBot) == 0 && this.state.botFixed_1 == true) {
                this.refs.scrollContentWrap.scrollTop = contentHeight;
                var scrollBarTop = 100 - parseFloat(scrollHeight);
                var scrollBarBot = 0;
                this.setState({
                    scrollBarTop: scrollBarTop,
                    scrollBarBot: scrollBarBot,
                    needScrollBar: true,
                    wrapHeight_1: wrapHeight,
                    contentHeight_1: contentHeight,
                    scrollHeight_1: scrollHeight
                });
            } else {
                var _scrollBarTop = parseFloat(scrollTop);
                var _scrollBarBot = 100 - (parseFloat(scrollHeight) + parseFloat(scrollTop));
                this.setState({
                    scrollBarTop: _scrollBarTop,
                    scrollBarBot: _scrollBarBot,
                    needScrollBar: true,

                    wrapHeight_1: wrapHeight,
                    contentHeight_1: contentHeight,
                    scrollHeight_1: scrollHeight
                });
            }
        }
    }, {
        key: "componentDidMount",
        value: function componentDidMount() {
            var scrollContentWrap = this.refs.scrollContentWrap;
            var scrollBarWidth = scrollContentWrap.offsetWidth - scrollContentWrap.clientWidth;
            this.setState({
                realScrollBarWidth: scrollBarWidth
            });
            if (this.props.botFixed) {
                this.setState({
                    botFixed_1: this.props.botFixed === "true"
                });
            }
            document.addEventListener("mouseup", this.handleMouseUp.bind(this));
            document.addEventListener("mousemove", this.handleMouseMove.bind(this));
        }
    }, {
        key: "handleScroll",
        value: function handleScroll() {
            var scrollBarTop = this.refs.scrollContentWrap.scrollTop / this.state.contentHeight_1 * 100;
            var scrollBarBot = 100 - (parseFloat(this.state.scrollHeight_1) + parseFloat(scrollBarTop));
            this.setState({
                scrollBarTop: scrollBarTop.toFixed(2),
                scrollBarBot: scrollBarBot.toFixed(2)
            });
            var requestFlag = this.props.requestFlag || false;
            if (scrollBarBot <= 5 && requestFlag) {
                this.props.requestDataBack ? this.props.requestDataBack() : null;
            }
        }
    }, {
        key: "handleMouseMove",
        value: function handleMouseMove(e) {
            //e.preventDefault();
            //e.stopPropagation();
            if (!this.state.mouseDown_1) return;
            var startPos = this.state.startPos_1;
            var changePos = startPos - e.clientY;
            this.setState({
                startPos_1: e.clientY
            });
            this.refs.scrollContentWrap.scrollTop -= changePos * this.state.contentHeight_1 / this.state.wrapHeight_1;
        }
    }, {
        key: "handleMouseUp",
        value: function handleMouseUp() {
            if (!this.state.mouseDown_1) return;
            this.setState({
                mouseDown_1: false
            });
        }
    }, {
        key: "handleMouseDown",
        value: function handleMouseDown(e) {
            this.setState({
                mouseDown_1: true,
                startPos_1: e.clientY
            });
        }
    }, {
        key: "render",
        value: function render() {
            var scrollContentWrap = eval('(' + JSON.stringify(style.scrollContentWrap) + ')');
            scrollContentWrap.right = "-" + this.state.realScrollBarWidth / 16 - 0.7 + "rem";

            var scrollBarWrap = eval('(' + JSON.stringify(style.scrollBarWrap) + ')');
            scrollBarWrap.width = this.state.scrollBarWidth / 16 + "rem";
            scrollBarWrap.borderRadius = this.state.scrollBarWidth / 2 / 16 + "rem";
            scrollBarWrap.backgroundColor = this.state.scrollWrapColor;

            var scrollBar = eval('(' + JSON.stringify(style.scrollBar) + ')');
            scrollBar.top = this.state.scrollBarTop + "%";
            scrollBar.bottom = this.state.scrollBarBot + "%";
            scrollBar.backgroundColor = this.state.scrollBarColor;

            var scrollBarDom = "";

            if (this.state.needScrollBar) {
                scrollBarDom = _react2.default.createElement(
                    "div",
                    { style: scrollBarWrap },
                    _react2.default.createElement("div", { onMouseDown: this.handleMouseDown.bind(this), style: scrollBar })
                );
            } else {
                scrollBarWrap.width = "0.5rem";
                scrollBarWrap.backgroundColor = "white";
                scrollBarDom = _react2.default.createElement("div", { style: scrollBarWrap });
            }

            return _react2.default.createElement(
                "div",
                { style: style.scrollBoxWrap },
                scrollBarDom,
                _react2.default.createElement(
                    "div",
                    { ref: "scrollContentWrap", style: scrollContentWrap, onScroll: this.handleScroll.bind(this) },
                    _react2.default.createElement(
                        "div",
                        { ref: "scrollContent" },
                        this.props.children
                    )
                )
            );
        }
    }]);

    return ScrollBox;
}(_react.Component);

exports.default = ScrollBox;
//# sourceMappingURL=gfy-scroll.js.map